#include <os.h>

#define KEYPAD_CHANNEL	3

typedef volatile unsigned int io_t;

int read_adc() {
	io_t *pmu1_disable = (io_t *)0x900B0018;
	io_t *pmu2_disable = (io_t *)0x900B0020;
	io_t *intmask = (io_t *)0xC4000004;
	io_t *cmd = (io_t *)(0xC4000100 + (KEYPAD_CHANNEL * 0x20));
	io_t *data = (io_t *)(0xC4000100 + (KEYPAD_CHANNEL * 0x20) + 0x10);

	*pmu1_disable &= ~(1<<4);
	*pmu2_disable &= ~(1<<4);

	*intmask = ~0;
	*cmd = 1;

	while (!(*intmask))
		idle();

	*intmask = ~0;

	return *data;
}

int main() {
	const char *type;
	char msg_buffer[128];
	int reading = read_adc();

	switch (reading / 21) {
		case 0:
			type = "Clickpad";
			break;
		case 1:
			type = "TI-84+";
			break;
		case 2:
			type = "Touchpad Prototype";
			break;
		case 3:
			type = "Touchpad";
			break;
		default:
			type = "Unknown";
			break;
	}

	sprintf(msg_buffer, "Type detected: %s\nRaw ADC value: %d\n",
		type, reading);
	show_msgbox("Keypad detection test", msg_buffer);

	return 0;
}
